# Funcoes para uso o IBQUOTA 2.4
# 2004-05-10   Valcir C. Vargas
#
# Teste: Copias de paginas
# Valcir Cabral: 24/06/2005
#
# Correcoes de Banner e Duplex : 02/01/2012
# 

sub COPIAS_IPP {
 my($path_job) = $SPOOL_IMPRESSORA;
 print "COPIAS: PATH ARQUIVO =$path_job\n";
 $path_job=$path_job. sprintf 'c%05d', $job;
 print "COPIAS: NOME ARQUIVO(c00000)=$path_job \n";
 if(-e $path_job){
    open FILE,$path_job;
    my $copias = 0;
    my @oqueprocura = (
                       "\x63","\x6f","\x70","\x69","\x65","\x73"
                       );
                       #copies
    my $i = 0;
    my $naoeh = 0;
    my $atual = "";
    my $anterior = "";
    local $/ = \2;  # Leitura de 2 bytes por vez
    while (<FILE>) {
       $atual=$_;
       if ($atual =~ /\x00\x06/) {
          $atual = <FILE>;
          if ($atual =~/\x63\x6f/){
             $atual = <FILE>;
             if ($atual =~/\x70\x69/){
                $atual = <FILE>;
                if ($atual =~/\x65\x73/){
                   $atual = <FILE>;
                   if ($atual =~/\x00\x04/){
                      $atual = <FILE>;
                      if ($atual =~/\x00\x00/){
                         local $/ = \1;  # Leitura de 1 byte por vez
                         $atual = <FILE>;
                         $atual = <FILE>;
                         $copias= ord($atual); ;
                         close (FILE);
                         return $copias;
                      }
                   }
                }
             }
          }
       }
    }   
 } else {
    if ($configuracoes{'DEBUG'} > 1) {
          print "COPIAS_IPP: Arquivo IPP (c00000) nao encontrado: $path_job\n";
    }
 }
 close (FILE);
 return 1;
}

sub EXECUTA_BANCO() {
 my($sql) = @_;
 my $i=0;
 my @executa_banco=`$configuracoes{'PATH_MYSQL'} -B -N -u $configuracoes{'USUARIO_BANCO'} -P$configuracoes{'PORTA_BANCO'} -p$configuracoes{'SENHA_BANCO'} -e "$sql" $configuracoes{'NOME_BANCO'}`;
   if ($configuracoes{'DEBUG'} > 1){ 
      print "\nSQL-> $sql\n";
   }
   if (`echo $?` != 0) {
     &GRAVA_LOG("Problema na formacao da SQL, verifique: \n $sql \n","ERRO");
     $executa_banco[0]="";
     return -1;
   }
 my $ii=0;
 my $w=0;
 my @lista_final;
  foreach $i (0..$#executa_banco){
     $lista_aux=$executa_banco[$i];
     $lista_aux =~ s/\n/|/g;
     @executa_nova = split(/\|/,$lista_aux);
     foreach $w (0..$#executa_nova) {
       $lista_final[$ii] = $executa_nova[$w];
       $ii = $ii +1;
       if ($configuracoes{'DEBUG'} > 1) {
          print "Elemento obtido na consulta ao banco de dados->$executa_nova[$w]\n";
       }
     }
  }
 if ($#executa_banco == -1) {
    return @executa_banco;
 } 
 

  #Remove o caracter \n do final dos campos
#  foreach $i (0..$#executa_banco) {
 #   $executa_banco[$i]=substr($executa_banco[$i],0,length($executa_banco[$i])-1);
  #}

   return @lista_final;
}

sub LER_CONFIGURACOES {
        my($cfgFile) = @_;
        print "ARQUIVO de configuracao: $cfgFile\n";
        my %cfg = ( TEMPO_DE_ESPERA => '10',
                    PATH_LPR => '/usr/bin/lpr',
                    PATH_LPSTAT => '/usr/bin/lpstat',
                    PATH_LPRM => '/usr/bin/lprm',
                    PATH_MYSQL => '/usr/local/mysql/bin/mysql',
                    NOME_BANCO => 'IBQUOTA',
                    PORTA_BANCO => '3306',
                    HOST_BANCO => '127.0.0.1',
                    USUARIO_BANCO => 'ibquota',
                    SENHA_BANCO => 'senha',
                    DEBUG => '0',
        );
       open CFGFile, $cfgFile or die "Erro ao abrir o arquivo de configuracao:$!";
       while(<CFGFile>){
        next if /^\s*#/ or /^\s*$/; #pula comentarios
        chomp;
        my($option, $value) = split(/\s+/, $_, 2);
        $cfg{$option} =  $value;
       }
       close (CFGFile);
       return %cfg;
}


sub INICIALIZA_QUOTA_PADRAO() {
 my @ar = localtime();
 my $dia=$ar[3];
 my $mes=$ar[4] + 1;
 my @executa=&EXECUTA_BANCO("select tipo_politica.tabela_modulo_perl,politica.cod_politica,
                                    politica.quota_acumulativa,politica.quota_padrao
                             from politica,tipo_politica,inicializacao
                             where politica.quota_infinita<>1 and
                             politica.cod_tipo_politica=tipo_politica.cod_tipo_politica and
                             politica.cod_politica=inicializacao.cod_politica and
                            (inicializacao.dia=0 or inicializacao.dia=$dia) and
                            (inicializacao.mes=0 or inicializacao.mes=$mes);");
 # if ($#executa_aux==0){
 #    my $lista_aux=$executa_aux[0];
 #    $lista_aux =~ s/\n/|/g;
 #    my @executa_nova = split(/\|/,$lista_aux);
 #    @executa=@executa_nova;
 #    print "------> $executa_nome[0]- NOVA\n";
 # } else {
 #    my @executa=@executa_aux;
 # print "------> $executa[0]- AUX\n"; 
 # }
 my $x=0;
 my $r="";
 my ($tabela_modulo_perl,$cod_politica,$quota_acumulativa,$quota_padrao) = ("",0,0,0);
 foreach $x (0..$#executa) {
    $r=$executa[$x];
    ($tabela_modulo_perl,$cod_politica,$quota_acumulativa,$quota_padrao) = split(/\s/,$r,4);
    if ($quota_acumulativa == 1) {
         @executa_outro=&EXECUTA_BANCO("update $tabela_modulo_perl set quota=$quota_padrao+quota \
                                         where  cod_politica=$cod_politica;");
         # Limitar o valor maximo da quota
         @executa_outro=&EXECUTA_BANCO("update $tabela_modulo_perl set quota=16000 \
                                         where  quota>16001 and cod_politica=$cod_politica;");
    } else {
         @executa_outro=&EXECUTA_BANCO("update $tabela_modulo_perl set quota=$quota_padrao \
                                         where  cod_politica=$cod_politica;");
    }
 }

}

sub VALOR_PAGINA_IMPRESSAO() {
 my($impressora,$login) = @_;
 my @executa=&EXECUTA_BANCO("select conjunto_impressora.valor_impressao \
                             from  conjunto_impressora,impressora,politica,usuario \
                             where conjunto_impressora.cod_impressora=impressora.cod_impressora and \
                                   conjunto_impressora.cod_politica=politica.cod_politica and \
                                   politica.cod_grupo=usuario.cod_grupo and \
                                   impressora.fila_virtual='$impressora' and
                                   usuario.login='$login';");
 my $valor=$executa[0];
 print "VALOR_PAGINA_IMPRESSAO: $valor | impressora: $impressora | login: $login \n\n";
 return $valor;
}

sub DEBITA_QUOTA_USUARIO() {
 my($arquivo_job,$login,$impressora) = @_;
 my $paginas=NUMERO_PAGINAS_JOB(&SPOOL_IMPRESSORA($impressora) . $arquivo_job);
 if ($paginas < 1) {
  #Nao foi possivel determinar quantidade de paginas
  &GRAVA_LOG_IMPRESSOES($login,$impressora,7);
  return 0;
 }
 my $quota=&QUOTA_LOGIN($impressora,$login);
 if ($quota == -1) {
   &GRAVA_LOG_IMPRESSOES($login,$impressora,1); 
   return 1;
 }
 $valor_por_pagina = &VALOR_PAGINA_IMPRESSAO($impressora,$login);
 $valorimpressao= $paginas * $valor_por_pagina;
 if ($valorimpressao < 0) {
  # Valor negativo 
  &GRAVA_LOG("Valor da impressao= $valorimpressao , usuario=$login , impressora=$impressora .", "ERRO");
  return 0;
 }
  my $tabela=&TABELA_QUOTA_IMPRESSAO($impressora,$login);
  @executa=&EXECUTA_BANCO("select $tabela.quota \
                               from $tabela,usuario,politica \
                               where  $tabela.cod_usuario=usuario.cod_usuario and \
                                      usuario.login='$login' and \
                                      $tabela.cod_politica=politica.cod_politica and \
                                      politica.cod_grupo=usuario.cod_grupo;");
  # Testa se a tabela existe
  if ($executa[0] == -1) {
    &GRAVA_LOG("Tabela: $tabela nao existe verificar a politica de impressao do $login.","ERRO");
    return 0;
  }

  my @contabiliza_banner=&EXECUTA_BANCO("select politica.contabiliza_banner
                                   from $tabela,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where $tabela.cod_usuario=usuario.cod_usuario
               and usuario.login='$login'
               and politica.cod_politica=$tabela.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");

  my @arquivo_banner=&EXECUTA_BANCO("select politica.arquivo_banner
                                   from $tabela,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where $tabela.cod_usuario=usuario.cod_usuario
               and usuario.login='$dono_job'
               and politica.cod_politica=$tabela.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");

  if ($arquivo_banner[0] eq "") {
       $contabiliza_banner=0;
  }

  if ($contabiliza_banner[0] == 1) {
      $valorimpressao = $valorimpressao + $valor_por_pagina;
  }

  # Existe quota suficiente?
  if ($valorimpressao > $executa[0]) {
      # 8 - Usuario com quota insuficiente
     &GRAVA_LOG_IMPRESSOES($login,$impressora,8);
     return 0;
  }
  #debitar da quota
  my $quotaatual=$executa[0] -$valorimpressao;
  @executa=&EXECUTA_BANCO("select $tabela.cod_modp  \
                               from $tabela,usuario,politica \
                               where  $tabela.cod_usuario=usuario.cod_usuario and \
                                      usuario.login='$login' and \
                                      $tabela.cod_politica=politica.cod_politica and \
                                      politica.cod_grupo=usuario.cod_grupo;");
  my $id_modp = $executa[0];
  @executa=&EXECUTA_BANCO("update $tabela set quota=$quotaatual \               
                               where  cod_modp=$id_modp;");
   &GRAVA_LOG_IMPRESSOES($login,$impressora,1);
  return 1;
}

sub LISTA_IMPRESSORAS() {
  my @executa=&EXECUTA_BANCO("select distinct impressora.fila_virtual \
                              from impressora, conjunto_impressora, politica \
                              where conjunto_impressora.cod_impressora=impressora.cod_impressora and \
                              conjunto_impressora.cod_politica=politica.cod_politica;");
  if ($#executa==0){
     $lista_aux=$executa[0];
     $lista_aux =~ s/\n/|/g;
     my @executa_nova = split(/\|/,$lista_aux);
    return @executa_nova;
  }
  return @executa;
}

sub LISTA_JOBS_IMPRESSORA() {
 my($impressora) = @_;
 my @lista_separada=split("-",$impressora);
 my $quant=$#lista_separada + 2;
 my @vet_jobs=`$configuracoes{'PATH_LPSTAT'} -P $impressora | grep "$impressora-" | cut -d"-" -f$quant | cut -d" " -f1`;

  if ($#vet_jobs==0){
     $lista_aux=$vet_jobs[0];
     $lista_aux =~ s/\n/|/g;
     my @executa_nova = split(/\|/,$lista_aux);
    return @executa_nova;
  }
return @vet_jobs;
}

sub SPOOL_IMPRESSORA() {
  my($impressora) = @_;
  my @executa=&EXECUTA_BANCO("select path_spool from impressora where fila_virtual='$impressora';");
  # Testar se o final da string eh um "/"
  #if (substr($executa[0],length($executa[0]),1) ne "//") {
  # $executa[0]=$executa[0] + "//";
  #} 
  return $executa[0];
}

sub TESTA_JOB() {
 my ($nome_arq_job) = @_;
 if(! -e "$nome_arq_job"){
  return 0;  
 }
 return 1;
}

sub MONTA_ARQUIVO_JOB() {
 my($job_a) = @_;
 return sprintf 'd%05d-001', $job_a;
}

sub GRAVA_LOG () {
 my($mensagem,$tipo) = @_;
 if (length($mensagem) < 1) {
  return 0;
 } 

 #NOME DO ARQUIVO DE LOG, ibquota.log
 my $log_arq="ibquota.log";

 my $data=`date "+%H:%M:%S %d-%m-%Y"`;
 if (`echo $?` == 1) {
  $data=`date`;
 }
 $data=substr($data,0,length($data)-1);
 `echo "$data - $tipo - $mensagem" >> $log_arq`;
 if ($configuracoes{'DEBUG'} > 0) {
    print "GRAVA_LOG: $data - $tipo - $mensagem \n";
 }
}

sub GRAVA_LOG_IMPRESSOES () {
 my($login,$impressora,$erro) = @_;
 my $estacao=&NOME_ESTACAO_JOB(&SPOOL_IMPRESSORA($impressora));
 my @cod_impressora=&EXECUTA_BANCO("select impressora.cod_impressora \
                               from impressora \
                               where  \
                                     impressora.fila_virtual='$impressora';");
 my @cod_usuario=&EXECUTA_BANCO("select cod_usuario \
                               from usuario \
                               where usuario.login='$login';");
 my $nome_documento=&NOME_TITULO_JOB(&SPOOL_IMPRESSORA($impressora));
 my $num_paginas=&NUMERO_PAGINAS_JOB(&SPOOL_IMPRESSORA($impressora) . &MONTA_ARQUIVO_JOB($job)); 
 if ($configuracoes{'DEBUG'} > 1) {
   print "GRAVA_LOG_IMPRESSOES: login=$login | estacao=$estacao | $nome_documento $num_paginas paginas \n";
 }
 my @cod_politica=&EXECUTA_BANCO("select politica.cod_politica \
                               from usuario,politica,impressora,conjunto_impressora \
                               where usuario.login='$login'  and \
                                     politica.cod_grupo=usuario.cod_grupo and \    
                                     conjunto_impressora.cod_politica=politica.cod_politica and \
                                     conjunto_impressora.cod_impressora=impressora.cod_impressora and \
                                     impressora.fila_virtual='$impressora';");
 
 my $formato=&FORMATO_ARQ(&SPOOL_IMPRESSORA($impressora) . &MONTA_ARQUIVO_JOB($job));
 my @cod_formato=&EXECUTA_BANCO("select formato.cod_formato \
                               from formato \
                               where formato.nome_formato='$formato';"); 
 my @executa=&EXECUTA_BANCO("insert into impressoes \  
                             values (0,$erro,$cod_impressora[0],$cod_usuario[0], \
                                     SYSDATE(),NOW(),$job,'$nome_documento',$num_paginas, \
                                     '$estacao',$cod_formato[0],$cod_politica[0]);");
return 0;    
}

sub FORMATO_ARQ(){
 my($arquivo_job) = @_;
 my $data;
 open FILE,$arquivo_job; # or die "Can't open the file: $!";
 read(FILE,$data,10*1024); #load only 10K from the file
 close (FILE);
 while($data){
        if($data =~ /^%!|\004%!|\033%-12345X%!PS|LANGUAGE\s?=\s?POSTSCRIPT/gi) {
                return "PS-PostScritp";
        } elsif ($data =~ /LANGUAGE=PCL3GUI/) {
                return "PCL3GUI";
        } elsif ($data =~ /LANGUAGE=PCLXL/){
                return "PCLXL";
        } elsif ($data =~ /\033E\033|\033%-12345X|LANGUAGE=\s?=\s?PCL/gi){
                return "PCL";
        } else {
                return "NONE";
        }
 }
}

sub REMOVE_JOB(){
 my($impressora,$job_a) = @_;
 `$configuracoes{'PATH_LPRM'} -P $impressora $job_a`;
 if ($configuracoes{'DEBUG'} > 1){
    print "REMOVE_JOB: job=$job_a da impressora: $impressora\n";
 }
 return (`echo $?`); 
}

sub DONO_JOB() {
 my($impressora,$job_a)= @_;
 my $impre_j=$impressora."-".$job_a;
 @dono =split(" ",`$configuracoes{'PATH_LPSTAT'} -P $impressora | grep $impre_j`);
 if ($dono[1] eq "") {
   $dono[1] = "NONE";
 }
 if ($configuracoes{'DEBUG'} > 0){
   print "DONO_JOB: $job_a dono:$dono[1]\n";
 }
 return $dono[1];
}

sub TABELA_QUOTA_IMPRESSAO() {
 my($impressora,$login)= @_;
 my @executa=&EXECUTA_BANCO("select tipo_politica.tabela_modulo_perl \
                             from tipo_politica, usuario, conjunto_impressora, impressora, politica, grupo \
                             where impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                               impressora.fila_virtual='$impressora' and \
                               conjunto_impressora.cod_politica=politica.cod_politica and \
                               politica.cod_grupo=grupo.cod_grupo and usuario.login='$login' and \
                               usuario.cod_grupo=grupo.cod_grupo and \
                               tipo_politica.cod_tipo_politica=politica.cod_tipo_politica;");
 return $executa[0];
}

sub QUOTA_LOGIN() {
 my($impressora,$login)= @_;
 my @executa=&EXECUTA_BANCO("select politica.quota_infinita \
                             from usuario, conjunto_impressora, impressora, politica, grupo \
                             where impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                               impressora.fila_virtual='$impressora' and \    
                               conjunto_impressora.cod_politica=politica.cod_politica and \
                               politica.cod_grupo=grupo.cod_grupo and usuario.login='$login' and \
                               usuario.cod_grupo=grupo.cod_grupo \
                               ;");
 # Quota infinita
 if ($executa[0] == 1 ){
  return -1;
 }
 

  $tabela=&TABELA_QUOTA_IMPRESSAO($impressora,$login);
  #
  # VERIFICAR NA TABELA ACIMA ENCONTRADA O CAMPO QUOTA
  #
  if ($tabela eq "grupop") {
    @executa1=&EXECUTA_BANCO("select grupop.quota 
                          from grupop,usuario,politica,impressora,conjunto_impressora 
                          where  grupop.cod_grupo=usuario.cod_grupo and 
                                 usuario.login='valcir' and 
                                 grupop.cod_politica=politica.cod_politica and 
                                 politica.cod_grupo=usuario.cod_grupo and 
                                 impressora.fila_virtual='HP1100' and 
                                 conjunto_impressora.cod_impressora=impressora.cod_impressora and
                                 conjunto_impressora.cod_politica=politica.cod_politica;");
  } else {
    @executa1=&EXECUTA_BANCO("select $tabela.quota \
                               from $tabela,usuario,politica \
                               where  $tabela.cod_usuario=usuario.cod_usuario and \
                                      usuario.login='$login' and \
                                      $tabela.cod_politica=politica.cod_politica and \
                                      politica.cod_grupo=usuario.cod_grupo;");
   # Testa se a tabela existe
   if ($executa1[0] == -1) {
    &GRAVA_LOG("Tabela: $tabela nao existe verificar a politica de impressao do $login.","ERRO");
    return 0;
   }
  }
  return $executa1[0];
}

sub EXECUTA_MODULO_IMPRESSAO_USUARIO(){
 local($dono_job,$impressora,$arquivo_job)=@_;
 my @executa=&EXECUTA_BANCO("select count(cod_usuario) \
                               from usuario \
                               where  login='$dono_job';");
 if($executa[0] == 0) { #Usuario nao cadastrado no banco.
  &GRAVA_LOG("Usuario nao cadastrado no banco de dados: $dono_job","INFO");
  &REMOVE_JOB($impressora,$job);
  return;
 }
 @executa=&EXECUTA_BANCO("select tipo_politica.funcao_perl \
                               from tipo_politica,usuario,politica,impressora,conjunto_impressora \
                               where  impressora.fila_virtual='$impressora' and \
                                      usuario.login='$dono_job' and \
                                      politica.cod_politica=conjunto_impressora.cod_politica and \     
                                      impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                                      politica.cod_grupo=usuario.cod_grupo and \
                                      tipo_politica.cod_tipo_politica=politica.cod_tipo_politica;");
 if ($executa[0] eq "") {
   &IMPRIME_JOB($dono_job,$impressora,$arquivo_job);
   &REMOVE_JOB($impressora,$job);
 } 
 elsif ($executa[0] eq "padrao") {
   &IMPRIME_JOB($dono_job,$impressora,$arquivo_job);
   &REMOVE_JOB($impressora,$job);
 } 
 else {
  #Se a funcao nao existir gravar no log de impressao 
  # e discartar job
  my $funcao=$executa[0];
# AINDA NAO SEI COMO TESTAR SE A FUNCAO EXISTE 
#  if (defined(&$funcao)) { 
#   &GRAVA_LOG_IMPRESSOES($dono_job,$impressora,9);
#   &REMOVE_JOB($impressora,$job);
#   &GRAVA_LOG("Verificar o modulo [ $funcao ] . Pois esta funcao nao existe. Job $job Cancelado.","ERRO");
#  } else {
#   # Chamar a funcao contida em $funcao!
   &$funcao;
#  }
 }
}

sub IMPRIME_JOB() {
 my($login,$impressora,$arquivo_job)=@_;
 my $resultado=1;
 if (&TESTA_QUOTA_INFINITA($login,$impressora) == 1) {
   # Quota INFINITA
   &IMPRIME_BANNER($login,$impressora);
   &MANDA_ARQ_IMPRESSORA($impressora,$arquivo_job,$login); 
   &GRAVA_LOG_IMPRESSOES($login,$impressora,1);
 } else { 
   if (&DEBITA_QUOTA_USUARIO($arquivo_job,$login,$impressora) == 1) {
     # OK
     &IMPRIME_BANNER($login,$impressora);
     &MANDA_ARQ_IMPRESSORA($impressora,$arquivo_job,$login);
   } else {
     # Nao OK
     $resultado=0;
     if ($configuracoes{'DEBUG'} > 0) {
       print "IMPRIME_JOB: O job=$job da impressora=$impressora nao pode ser impresso\n";
     }
   } 
 }
 return $resultado;   
}

sub IMPRIME_BANNER() {
 my($login,$impressora)=@_;
 my @arq_banner=&EXECUTA_BANCO("select politica.arquivo_banner  \
                               from politica,impressora,usuario,conjunto_impressora \
                               where  impressora.fila_virtual='$impressora' and \
                                      impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                                      conjunto_impressora.cod_politica=politica.cod_politica and \
                                      politica.cod_grupo=usuario.cod_grupo and \
                                      usuario.login='$login';");
 if ($arq_banner[0] eq "") { #Politica sem banner
   return;
 }
 $arq_banner[0]= "./banner/" . $arq_banner[0]; 
 my $arq_temp_banner=&SPOOL_IMPRESSORA($impressora)."arq_temp.banner";
 if(-e $arq_banner[0]){
  if(TESTA_QUOTA_INFINITA($login,$impressora) == 1){
   $quota_atual="Quota infinita.";
  } else {
   $quota_atual=&QUOTA_LOGIN($impressora,$login);
  }
  my @ar = localtime();
  my $hora=$ar[2].":".$ar[1];
  $ar[4]= $ar[4] + 1;
  my $data=$ar[3]."/".$ar[4]."/".substr($ar[5],1,2);
  my $banner;
  my $paginas_job=&NUMERO_PAGINAS_JOB(&SPOOL_IMPRESSORA($impressora).&MONTA_ARQUIVO_JOB($job));
  open FILE, "$arq_banner[0]" or die "Erro ao abrir o arquivo:  ($!)";
  { local $/=undef; $banner = <FILE>; }
  $banner =~ s/_USUARIO_/$login/g;
  $banner =~ s/_JOB_/$job/g;
  $banner =~ s/_HORA_/$hora/g;
  $banner =~ s/_DATA_/$data/g;
  $banner =~ s/_QUOTA_ATUAL_/$quota_atual/g;
  $banner =~ s/_IMPRESSORA_/$impressora/g;
  $banner =~ s/_PAGINAS_/$paginas_job/g;
  close (FILE);
  open(ARQ1,">$arq_temp_banner");
  print ARQ1 $banner;
  close (ARQ1);
  &MANDA_ARQ_IMPRESSORA($impressora,"arq_temp.banner","banner-".$login) ;
 # `rm $arq_temp_banner`;
 } else {
  &GRAVA_LOG("Arquivo de banner: $arq_banner[0] nao encontrado.","ERRO");
 }
}

sub DUPLEX{
         my($arquivo_job) = @_;
         open FILE,$arquivo_job;
         my $oqueprocura = ("\x44\x75\x70\x6c\x65\x78\x4e\x6f\x54\x75\x6d\x62\x6c\x65"); #DuplexNoTumble
         my $oqueprocura2 = ("\x44\x75\x70\x6c\x65\x78\x54\x75\x6d\x62\x6c\x65");#DuplexTumble
         my $i = 0;
         my $atual = "";
         my $x = 0;
         local $/ = \1;  # Leitura de byte a byte
         while (<FILE>) {
                  $atual=$_;
                  $x="$x$atual";
        }
        if ($x=~/$oqueprocura/) {
            close (FILE);
            return "-o Duplex=DuplexNoTumble";
        }
        elsif ($x=~/$oqueprocura2/) {
            close (FILE);
            return "-o Duplex=DuplexTumble";
        }
        close (FILE);
        return "" ;
}


sub MANDA_ARQ_IMPRESSORA() {
 my($impressora,$arquivo_job,$login)=@_;
 my @impressora_real=&EXECUTA_BANCO("select impressora.fila_real  \
                               from impressora \
                               where  impressora.fila_virtual='$impressora';");
 my $fila_impressao=&SPOOL_IMPRESSORA($impressora);
 my $arquivo=$fila_impressao . $arquivo_job;

 my($path_job) = $SPOOL_IMPRESSORA;
 $path_job=$path_job. sprintf 'c%05d', $job;
 my $duplex=&DUPLEX("$path_job");
 `cat $arquivo | $configuracoes{'PATH_LPR'} $duplex -P $impressora_real[0] -C $login`;

 return (`echo $?`);
}


sub DORMIR() {
 my($tempo_espera)=@_;
 `sleep $tempo_espera`;
}


sub DIA_DO_MES {
  return (localtime(time))[3];
}

sub NOME_ESTACAO_JOB{
        my($arquivo_job) = @_;
        $arquivo_job=$arquivo_job. sprintf 'c%05d', $job;
        if(-e $arquivo_job){
                open FILE,$arquivo_job;
                my $estacao = "";
                my @oqueprocura = ("\x6a","\x6f","\x62","\x2d","\x6f","\x72","\x69","\x67","\x69",
                                   "\x6e","\x61","\x74","\x69","\x6e","\x67","\x2d","\x68","\x6f",
                                   "\x73","\x74","\x2d","\x6e","\x61","\x6d","\x65");
                                   #job-originating-host-name
                my $i = 0;
                my $naoeh = 0;
                my $atual = "";
                my $anterior = "";
                local $/ = \1;  # Leitura de byte a byte
                while (<FILE>) {
                      $atual=$_;
                       if ($atual =~ /\x00/) {
                         $atual = <FILE>;
                         $naoeh=0;
                         $i=-1;
                         while ($i != $#oqueprocura) {
                            $i++;
                            $atual = <FILE>;
                            if ($atual =~ /$oqueprocura[$i]/) {
                               $fim=0;
                            } else {
                               $naoeh=1;
                            }
                           if ($naoeh == 1) {
                              $i = $#oqueprocura;
                           }
                         }
                         if ($naoeh == 0) {
                            $atual=<FILE>;
                            $atual=<FILE>;
                            $fim=0;
                            while ($fim==0) {
                              $atual=<FILE>;
                              if ($atual =~ /\x00/){
                                $fim=1;
                              } else {
                                $estacao= $estacao . $anterior;
                              }
                              $anterior=$atual;
                            }
                            close (FILE);
                            return $estacao;
                         }
                       }
                }
                close (FILE);
        }
        return "NONE";
}

sub NOME_TITULO_JOB{
        my($arquivo_job) = @_;
        $arquivo_job=$arquivo_job. sprintf 'c%05d', $job;
        if(-e $arquivo_job){
                open FILE,$arquivo_job;
                my $titulo = "";
                my @oqueprocura = ("\x6a","\x6f","\x62","\x2d",
                                   "\x6e","\x61","\x6d","\x65");
                                   #job-name
                my $i = 0;
                my $naoeh = 0;
                my $atual = "";
                my $anterior = "";
                local $/ = \1;  # Leitura de byte a byte
                while (<FILE>) {
                      $atual=$_;
                       if ($atual =~ /\x00/) {
                         $atual = <FILE>;
                         $naoeh=0;
                         $i=-1;
                         while ($i != $#oqueprocura) {
                            $i++;
                            $atual = <FILE>;
                            if ($atual =~ /$oqueprocura[$i]/) {
                               $fim=0;
                            } else {
                               $naoeh=1;
                            }
                           if ($naoeh == 1) {
                              $i = $#oqueprocura;
                           }
                         }
                         if ($naoeh == 0) {
                            $atual=<FILE>;
                            $atual=<FILE>;
                            $fim=0;
                            while ($fim==0) {
                              $atual=<FILE>;
                              if ($atual =~ /\x00/){
                                $fim=1;
                              } else {
                                $titulo= $titulo . $anterior;
                              }
                              $anterior=$atual;
                            }
                            close (FILE);
                            return $titulo;
                         }
                       }
                }
                close (FILE);
        }
        return "NONE";
}

sub NUMERO_PAGINAS_JOB() {
 my ($arquivo_job)=@_;
 my $num_paginas=0;
 my $formato=&FORMATO_ARQ($arquivo_job);
 if ($formato eq "PS-PostScritp") {
  $num_paginas=&PSCOUNTER($arquivo_job);
 }
 if ($formato eq "PCL") {
  $num_paginas=&PCLCOUNTER($arquivo_job);
 }
 if ($formato eq "PCL3GUI") {
  $num_paginas=&PCL3GUICOUNTER($arquivo_job);
 }
 if ($formato eq "PCLXL") {
  $num_paginas=&PCLXLCOUNTER($arquivo_job);
 }
 if ($formato eq "NONE") {
  &GRAVA_LOG("Formato de arquivo invalido $arquivo_job","ERRO");
 }
 if ($num_paginas < 0) {
  $num_paginas=0;
 }

 my $copias=&COPIAS_IPP($arquivo_job);
 if ($copias < 1) { $copias=1; }
 return ($num_paginas * $copias) ;
}

sub PSCOUNTER() {
 my($arquivo)=@_;
 open ARQ, "$arquivo";
 my $copias = 1;
 my $total = 0;
 my $paginas = 0;
 my $copias_job = 0;
 while (<ARQ>) {
  chomp;
  if ($_ =~ "%%Page: ") {
    $paginas++;
  }

  if ($_ =~ /^ (\d+) \@copies$/) {
     $copias = $1;
  }
 }

 $copias_job=`cat $arquivo | grep '#copies' | tail -1 | cut -d' ' -f2`;
 if ($copias_job eq ""){
   $copias_job=0;
 }
 if ($copias_job > $copias) {
   $copias = $copias_job;
 }
 my $copias1=`cat $arquivo | grep 'RBINumCopies:' | tail -1 | cut -d' ' -f2`;
 if ($copias < $copias1) {
   $copias=$copias1;
 }
 if ($copias < 1) {
   $copias = 1;
 }

 $total =$paginas * $copias;
 if ($configuracoes{'DEBUG'} > 1) {
    print "Paginas = $paginas \nCopias = $copias  \nTOTAL = $total\n";
 }
 close (ARQ);
 return $total;
}

sub PCLCOUNTER{
        my($pclFile) = @_;
        if(-e $pclFile){
                open FILE,$pclFile;
                my($Pages, $Copies) = (0, 0);
                local $/ = \1;  # read one byte at a time
                while (<FILE>) {
                        if ($_ eq "\f") { $Pages++ }
                        elsif ($_ eq "\e") {
                                my $tag = <FILE> . <FILE>;  # read two bytes
                                if ($tag eq '*b' or $tag eq '(s' or $tag eq ')s' or $tag eq '&p'){
                                        my $end = ($tag eq '&p') ? 'X' : 'W';
                                        my $size = "0";
                                        while (<FILE>) {
                                                if (/\d/) { $size .= $_ }
                                                else { last }
                                        }
                                        if ($_ eq $end) {
                                                seek(FILE, $size, 1);
                                                my $pos = tell FILE;
                                        } else {
                                                $size = 0;
                                        }
                                } elsif ($tag eq '&l') {
                                        my $n = "";
                                        while (<FILE>) {
                                                if (/\d/) { $n .= $_ }
                                                else { last }
                                        }
                                        if ($_ eq 'X') {
                                                $Copies = $n;
                                        }
                                }
                        }
                }
                close (FILE);
                if ($Copies == 0) {
                  $Copies=1;
                }
                return $Copies * $Pages;
        } else {
                return -1;
        }
}

sub PCL3GUICOUNTER(){
 my($arquivo_job) = @_;
 open ARQ, "$arquivo_job" or die "Problemas na abertura do arquivo $arquivo: $!";
 my $paginas = 0;
 while (<ARQ>) {
        chomp;
        if (/\x1B\*r1A/) {
                $paginas = $paginas + 1;
        }
 }
 close ARQ;
 return $paginas;
}

sub PCLXLCOUNTER{
      my($arquivo_job) = @_;
      if(-e $arquivo_job){
              open FILE,$arquivo_job;
              my $paginas = 0;
              my($atual,$umatras,$doisatras,$tresatras,$quatroatras,$cintoatras) =("","","","","");
              local $/ = \1;  # Leitura de byte a byte
              while (<FILE>) {
                    $cintoatras=$quatroatras;
                    $quatroatras=$tresatras;
                    $tresatras=$doisatras;
                    $doisatras=$umatras;
                    $umatras=$atual;
                    $atual=$_;
                    if ($atual =~ /\x44/) {
                      if ($umatras =~ /\x31/) {
                        if ($doisatras =~ /\xf8/) {
                          if ($tresatras =~ /\x00/) {
                            if ($cintoatras =~ /\xc1/) {
                              $paginas = $paginas + ord($quatroatras);
                            }
                          }
                        }
                      }
                    }
              }
              close (FILE);
              return $paginas;
    } else {
              return -1;
    }
}

sub TESTA_QUOTA_INFINITA() {
 my($login,$impressora)=@_;
 my @executa=&EXECUTA_BANCO("select politica.quota_infinita \
                               from usuario,politica,impressora,conjunto_impressora \
                               where  impressora.fila_virtual='$impressora' and \
                                      usuario.login='$login' and \
                                      politica.cod_politica=conjunto_impressora.cod_politica and \
                                      impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                                      politica.cod_grupo=usuario.cod_grupo;");

 return $executa[0]; 
}

sub TESTA_QUOTA_ACUMULATIVA() {
 my($login,$impressora)=@_;
 my @executa=&EXECUTA_BANCO("select politica.quota_acumulativa \
                               from usuario,politica,impressora,conjunto_impressora \
                               where  impressora.fila_virtual='$impressora' and \
                                      usuario.login='$login' and \
                                      politica.cod_politica=conjunto_impressora.cod_politica and \
                                      impressora.cod_impressora=conjunto_impressora.cod_impressora and \
                                      politica.cod_grupo=usuario.cod_grupo;");
    
 return $executa[0];
}

print "Iniciando IBQUOTA...\n";
