<?php
/**************************************************
* atribui_politica.php                            *
*                                                 *
* Atribui Politica de Impressao um grupo          *
* Associa um grupo de usurio com uma impressora, *
*       e grava parametros de quota para cada     *
*       usuario do grupo.                         *  
*                                                 *
* Criado em: 24/06/2004 - Valcir C. Vargas        *
* Alterado em: 19/12/2012 - Valcir C              *
*            - Variavel metodo Post de formulario *
**************************************************/


$titulo = "Atribuir Pol&iacute;tica de Impress&atilde;o";
include 'cabecalho.php';

if (isset($_POST["acao"])) {
   $acao = $_POST["acao"];
} else {
   $acao = 0;
}

if (isset($_POST["cod_grupo"])) {
   $cod_grupo = $_POST["cod_grupo"];
} else {
   $cod_grupo = -1;
}

if (isset($_POST["cod_tipo_politica"])) {
   $cod_tipo_politica = $_POST["cod_tipo_politica"];
} else {
   $cod_tipo_politica = -1;
}


?>
<?php
// INICIO DO CORPO DA PAGIN
Mostra_M_Titulo("Atribuir Pol&iacute;tica de Impress&atilde;o");

if ($acao==0) {
    // Verifica se ha grupos cadastrados
    $sql = "SELECT * from grupo";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("N&atilde;o h&aacute; grupos cadastrados no sistema");
      include 'rodape.php';
      exit(0);
    }
    // Verifica se ha impressoras cadastradas
    $sql = "SELECT * from impressora";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("N&atilde;o h&aacute; Impressoras cadastradas no sistema.");
      include 'rodape.php';
      exit(0);
    }

    // Verifica se ha tipos de politicas cadastradas
    $sql = "SELECT * from tipo_politica";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("N&atilde;o h&aacute; Tipos de Pol&iacute;ticas de Impress&atilde;o cadastrados no sistema. Muito provavelmente houve erro na instala&ccedil;&atilde;o do IBQUOTA ou o Banco de Dados foi alterado, pois o IBQUOTA vem, por padr&atilde;o, com algumas pol&iacute;ticas de impress&atilde;o.");
      include 'rodape.php';
      exit(0);
    }
    $destino_pagina=$_SERVER['PHP_SELF'];
    echo " <form name=\"politica\" method=\"post\" action=\"$destino_pagina\"> <br> \n";
    echo "<input type=\"hidden\" name=\"acao\" value=\"1\"> \n";
    echo "<p><br>&nbsp;&nbsp;&nbsp;Aplicar a pol&iacute;tica de impress&atilde;o no grupo: </b>";
    // Monta Combo Grupo
    $sql = "SELECT * from grupo";
    $mysql->exesql($sql);
    echo "<select name=\"cod_grupo\" size=\"1\"> \n";
    $achou = mysql_num_rows($mysql->consulta);
    for ($I=0;$I<>$achou;$I++) {
      $row = mysql_fetch_row($mysql->consulta);
      $cod_grupo = $row[0];
      $nome_grupo = $row[1];
      echo "<option value=\"$cod_grupo\">$nome_grupo</option>\n";
    }
    echo "</select><br></p>\n";

    // Monta Combo Politica
    $sql = "SELECT * from tipo_politica";
    $mysql->exesql($sql);
   ?>
    <center>
    <table align="center" bordercolor="#FFFFFF" width="95%" border="1" cellspacing="0" cellpadding="0">
     <tr bgcolor="#666666">
       <td width="10%"><div align="center"><strong>Tipo Pol&iacute;tica</strong></div></td>
       <td width="15%"><div align="center"><strong>Descri&ccedil;&atilde;o</strong></div></td>
     </tr>
   <?php
    $achou = mysql_num_rows($mysql->consulta);
    $I=1;
    for ($W=0;$W<>$achou;$W++) {
      $row = mysql_fetch_row($mysql->consulta);
      $cod_tipo_politica = $row[0];
      $nome_tipo_politica = $row[1];
      $descricao_tipo_politica = $row[2];
      $quota_acumulativa = $row[6];
      $quota_infinita = $row[7];
      $banner = $row[8];
      $autor = $row[9] ."-". $row[10];
      if ($I==1) {
         echo "<tr>";
         $I=0;
       } else {
         echo "<tr bgcolor=#669999>";
         $I=1;
       }
       echo "<td><input type=\"radio\" name=\"cod_tipo_politica\" size=\"1\" value=\"$cod_tipo_politica\"> \n";
       echo "</td>\n";
       echo "<td>$descricao_tipo_politica <br> \n
                 <b>Aceita Quota Acumulativa:</b> ";
             if ($quota_acumulativa == 1) {
               echo "SIM <br> \n";
             } else {
               echo "N&atilde;o <br> \n";
             }
             echo "<b>Aceita Quota Infinita:</b> ";
             if ($quota_infinita == 1) {
               echo "SIM <br> \n";
             } else {
               echo "N&atilde;o <br> \n";
             }
             echo "<b>Aceita Banner:</b> ";
             if ($banner == 1) {
               echo "SIM <br> \n";
             } else {
               echo "N&atilde;o <br> \n";
             }
       echo "</td>\n";
       echo "</tr>\n";

     }

     ?>
     <tr bgcolor="#666666">
       <td>&nbsp;</td>
       <td>&nbsp;</td>
     </tr>
   </table>
   <?php
    echo "<br>";
    echo " <center><br><input type=\"reset\" value=\"Restaurar Campos\">\n";
    echo " <input type=\"submit\" value=\"Enviar 1/2\">\n</center>";
    echo " </form><br>\n";
}



 // Segunda parte do cadastro
 if ($acao==1) {
    if (($cod_grupo<1) or ($cod_tipo_politica<1)) {
      Mostra_M_Erro("Grupo ou Tipo de Pol&iacute;tica inv&aacute;lido!");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
    // VERIFICA SE Ha IMPRESSORA CADASTRADA NO SISTEMA
    $sql = "select impressora.*
              from impressora";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("N&atilde;o h&aacute; impressoras cadastradas no sistema");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
    // Verifica grupo
    $sql = "SELECT * from grupo where cod_grupo=$cod_grupo";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("Grupo n&atilde;o cadastrado no sistema");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
    $row = mysql_fetch_row($mysql->consulta);
    $nome_grupo= $row[1];
    // Verifica tipo de politicas
    $sql = "SELECT * from tipo_politica where cod_tipo_politica=$cod_tipo_politica";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    if ($achou < 1){
      Mostra_M_Erro("Tipos de Pol&iacute;tica de Impress&atilde;o n&atilde;o cadastrada no sistema");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
      $row = mysql_fetch_row($mysql->consulta);
      $cod_tipo_politica = $row[0];
      $nome_tipo_politica = $row[1];
      $descricao_tipo_politica = $row[2];
      $quota_acumulativa = $row[6];
      $quota_infinita = $row[7];
      $banner = $row[8];
      $autor = $row[9] ."-". $row[10];
      echo "<center>\n";
      echo "A pol&iacute;tica de impress&atilde;o <b>$nome_tipo_politica</b> ser&aacute; aplicada no grupo <b>$nome_grupo</b>.<br> \n";
      echo "</center><br>\n";
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo " <form name=\"politica\" method=\"post\" action=\"$destino_pagina\">\n";
      echo "<input type=\"hidden\" name=\"acao\" value=\"2\"> \n";
      echo "<input type=\"hidden\" name=\"cod_grupo\" value=\"$cod_grupo\"> \n";
      echo "<input type=\"hidden\" name=\"cod_tipo_politica\" value=\"$cod_tipo_politica\"> \n";

      echo "<b>Quota Padr&atilde;o: </b>\n";
      echo "<INPUT TYPE =\"text\" name=\"quota_padrao\" value=\"100\" size=\"5\" maxlength=\"5\"><br>\n";

      if ($quota_acumulativa == 1) {
           echo "<input type=\"checkbox\" name=\"quota_acumulativa\" value=\"1\"><b>Quota Acumulativa</b><br> \n";
      }
      if ($quota_infinita == 1) {
           echo "<input type=\"checkbox\" name=\"quota_infinita\" value=\"1\"><b>Quota Infinita</b><br> \n";
      }
      if ($banner == 1) {
           echo "<input type=\"checkbox\" name=\"contabiliza_banner\" value=\"1\"><b>Contabilizar Banner</b><br> \n";

           echo "<b>Banner (folha de rosto):</b> \n";
           // Colocar aqui a Fun�o que lista os tipos banners disponiveis
           // PROVISORIO
           echo "<select name=\"arquivo_banner\" size=\"1\"> \n";
           echo " <option value=\"\" selected>Sem banner</option>\n";
           $dir="../banner/"; // Precisa ler apenas arquivos .banner
           $dir_handle = opendir($dir);
           while($filename = readdir($dir_handle)){
             if(!is_dir($filename)){
			     if (substr($filename,strlen($filename)-6) == "banner"){
                     echo " <option value=\"$filename\">$filename</option>\n";
				 }
             }
           }
           closedir($dir_handle);
           echo "</select><br>\n";

      }
      echo "<br><br><center>\n";
      echo "IMPRESSORAS \n";
      echo "</center><br>\n";
      $sql = "select distinct impressora.*
              from impressora";
      $mysql->exesql($sql);
      $achou = mysql_num_rows($mysql->consulta);
      ?>
      <center>
      <table align="center" bordercolor="#FFFFFF" width="95%" border="1" cellspacing="0" cellpadding="0">
       <tr bgcolor="#666666">
         <td><div align="center"><strong>&nbsp;</strong></div></td>
         <td><div align="center"><strong>Impressora</strong></div></td>
         <td><div align="center"><strong>Descri&ccedil;&atilde;o</strong></div></td>
         <td><div align="center"><strong>Valor de cada p&aacute;gina*</strong></div></td>
       </tr>
      <?php
      $I=1;
      for ($W=0;$W<>$achou;$W++) {
         $row = mysql_fetch_row($mysql->consulta);
         $cod_impressora = $row[0];
         $descricao_impressora = $row[2];
         $fila_virtual = $row[4];
         if ($I==1) {
           echo "<tr>";
           $I=0;
         } else {
           echo "<tr bgcolor=#669999>";
           $I=1;
         }
         echo " <td><input name=\"cod_impressora[$W]\" value=\"$cod_impressora\" type=\"checkbox\"> </td>\n";
         echo " <td>$fila_virtual </td>\n";
         echo " <td>$descricao_impressora </td>\n";

         echo " <td align=\"right\">\n";
         echo "  <INPUT TYPE =\"text\" name=\"impressora_valor[$W]\" value=\"1\" size=\"5\" maxlength=\"5\"><br>\n";
         echo " </td>\n";

         echo "</tr>\n";

      }

      ?>
       <tr bgcolor="#666666">
         <td>&nbsp;</td>
         <td>&nbsp;</td>
         <td>&nbsp;</td>
         <td>&nbsp;</td>
       </tr>
      </table>
      </center>
      <small>* O "Valor de Cada P&aacute;gina" &eacute; o valor descontado da quota do usu&aacute;rio por cada p&aacute;gina impressa. &Eacute; poss&iacute;vel aplicar valores quebrados, exemplo: "0,5". Valor padr&atilde;o=1.<br>
      Aten&ccedil;&atilde;o: As impressoas associadas a este grupo em outras pol&iacute;ticas de impress&atilde;o n&atilde;o aparecem na listagem acima. </small>
      <br><br>
      <?php
      echo "<input type=\"checkbox\" name=\"conjunto_impressora\" value=\"1\"><b>Compartilha a mesma quota entre as impressoras.</b><br> (Ex: Dada uma quota de 100 p&aacute;ginas para o usu&aacute;rio \"jose\", ele ter&aacute; direito de imprimir 50 em uma impressora e 50 noutra, e nada mais.) Se n&atilde;o entendeu o que significa, n&atilde;o selecione. <br>\n";

      echo " <br><br>\n";
      echo "<center>INICIALIZA&Ccedil;&Atilde;O AUTOMATICA DE QUOTA</center><br>\n";
      echo "<input type=\"radio\" name=\"inicializacao\" size=\"1\" value=\"0\" checked> \n";
      echo " Nunca<br>\n";

      echo "<input type=\"radio\" name=\"inicializacao\" size=\"1\" value=\"1\"> \n";
      echo " Todos os Dias<br>\n";

      echo "<input type=\"radio\" name=\"inicializacao\" size=\"1\" value=\"2\"> \n";
      echo " Todos os in&iacute;cios de Mes (Tipo mais utilizado)<br>\n";

      echo "<input type=\"radio\" name=\"inicializacao\" size=\"1\" value=\"3\"> \n";
      echo " Todos os dias 1 de Janeiro e 1 de Julho<br>\n";

      echo "<input type=\"radio\" name=\"inicializacao\" size=\"1\" value=\"4\"> \n";
      echo " Todos in&iacute;cios de Meses impares (Janeiro,Mar&ccedil;o,Maio,Julho,Setembro e Novembro)<br>\n";

      echo "<br><br>\n";

      echo "  <center><br><input type=\"reset\" value=\"Restaurar Campos\">\n";
      echo "  <input type=\"submit\" value=\"Enviar 2/2\">\n</center>";
      echo "</form><br>\n";

 }

 // Atribui finalmente a politica
 if ($acao==2) {
    if (($cod_grupo<1) or ($cod_tipo_politica<1)) {
      Mostra_M_Erro("Grupo ou Tipo de Politica inv&aacute;lido!");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
    
    if (isset($_POST["cod_impressora"])) {
       $cod_impressora = $_POST["cod_impressora"];
    } else {
       $cod_impressora = 0;
    }

    if (isset($_POST["quota_padrao"])) {
       $quota_padrao = $_POST["quota_padrao"];
    } else {
       $quota_padrao = 0;
    }

    if (isset($_POST["quota_acumulativa"])) {
       $quota_acumulativa = $_POST["quota_acumulativa"];
    } else {
       $quota_acumulativa = 0;
    }
    
    if (isset($_POST["quota_infinita"])) {
       $quota_infinita = $_POST["quota_infinita"];
    } else {
       $quota_infinita = 0;
    }
    
    if (isset($_POST["contabiliza_banner"])) {
       $contabiliza_banner = $_POST["contabiliza_banner"];
    } else {
       $contabiliza_banner = 0;
    }
    
    if (isset($_POST["impressora_valor"])) {
       $impressora_valor = $_POST["impressora_valor"];
    } else {
       $impressora_valor = 0;
    }    
        
    if (isset($_POST["conjunto_impressora"])) {
       $conjunto_impressora = $_POST["conjunto_impressora"];
    } else {
       $conjunto_impressora = 0;
    }    
    
    if (isset($_POST["arquivo_banner"])) {
       $arquivo_banner = $_POST["arquivo_banner"];
    } else {
       $arquivo_banner = 0;
    }    

    if (isset($_POST["inicializacao"])) {
       $inicializacao = $_POST["inicializacao"];
    } else {
       $inicializacao = 0;
    }

    
    if ((sizeof($cod_impressora)<1) or (sizeof($impressora_valor)<1)) {
      Mostra_M_Erro("Deve-se selecionar, no m&iacute;nimo, uma impressora!");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);
    }
    if ($quota_padrao<1) {
       $quota_padrao=0;
    }
    if ($quota_acumulativa!=1) {
       $quota_acumulativa=0;
    }
    if ($quota_infinita!=1) {
       $quota_infinita=0;
    }
    if ($contabiliza_banner!=1) {
       $contabiliza_banner=0;
    }
 
    // Limpa o Vetor de codigos de impressora
    $sql="select impressora.*
          from impressora";
    $mysql->exesql($sql);
    $achou = mysql_num_rows($mysql->consulta);
    $cod_real=0;
    for ($x=0;$x<>$achou;$x++){
      if (isset($cod_impressora[$x])) {
         $cod_impressora_limpo[$cod_real]=$cod_impressora[$x];
         $impressora_valor[$cod_real]=str_replace(",", ".", $impressora_valor[$x]);
         $cod_real++;
      }
    }
    
    if ($cod_real < 1 ) {
      Mostra_M_Erro("Deve-se selecionar, no m&iacute;nimo, uma impressora!");
      $destino_pagina=$_SERVER['PHP_SELF'];
      echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
      include 'rodape.php';
      exit(0);    
    }
    $cod_impressora=$cod_impressora_limpo;
    // Verifica se a impressora(s) passada(s) por parametro ja estao) ligadas ao grupo
    for ($x=0;$x<count($cod_impressora);$x++){
         $sql="select impressora.*
               from impressora,conjunto_impressora,politica
               where politica.cod_grupo=$cod_grupo and
                     conjunto_impressora.cod_politica=politica.cod_politica and
                     impressora.cod_impressora=conjunto_impressora.cod_impressora and
                     impressora.cod_impressora=$cod_impressora[$x]";
         $mysql->exesql($sql);
         $achou = mysql_num_rows($mysql->consulta);
         if ($achou>0){
            $row = mysql_fetch_row($mysql->consulta);
            Mostra_M_Erro("A impressora $row[4] est&aacute; selecionada em uma pol&iacute;tica de impress&atilde;o existente para este grupo. N&atilde;o &eacute; permitido ligar uma mesma impressora mais de uma vez com um mesmo grupo.");
            $destino_pagina=$_SERVER['PHP_SELF'];
            echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
            include 'rodape.php';
            exit(0);
         }
     } // endFor



    // Compartilha quota com v�ias impressoras
    if ($conjunto_impressora==1) {
         // Cadastra Politica
         $sql="INSERT INTO politica (cod_politica,cod_tipo_politica,cod_grupo,quota_acumulativa,
                                quota_infinita,arquivo_banner,contabiliza_banner,quota_padrao)
                  VALUES(0,$cod_tipo_politica,$cod_grupo,$quota_acumulativa,$quota_infinita,
                        '$arquivo_banner',$contabiliza_banner,$quota_padrao)";
         $mysql->exesql($sql);
         $sql="SELECT max(politica.cod_politica) from politica";
         $mysql->exesql($sql);
         $row = mysql_fetch_row($mysql->consulta);
         $cod_politica = $row[0];
         if ($quota_infinita == 0) {
              // Obtem usu�ios do grupo
              $sql="SELECT usuario.cod_usuario from usuario
                    where usuario.cod_grupo=$cod_grupo";
              $mysql->exesql($sql);
              $achou = mysql_num_rows($mysql->consulta);
              for ($cod=0;$cod<>$achou;$cod++) {
                  $row = mysql_fetch_row($mysql->consulta);
                  $vet_cod_usuario[$cod]  = $row[0];
              }
              // Nome da tabela do modulo para se atualizar
              $sql="SELECT tipo_politica.tabela_modulo_perl from tipo_politica
                    where tipo_politica.cod_tipo_politica=$cod_tipo_politica";
              $mysql->exesql($sql);
              $row = mysql_fetch_row($mysql->consulta);
              $tabela_modulo_perl = $row[0];
              if (($tabela_modulo_perl == "") or ($tabela_modulo_perl == "padrao") or ($tabela_modulo_perl == "0")) {
                   $tabela_modulo_perl="modp";
              }
			  $jafez=0;
			  if ($tabela_modulo_perl == "grupop"){
			     $jafez=1;
                 $sql="INSERT INTO grupop (cod_grupop,cod_grupo,quota,cod_politica)
                         VALUES (0,$cod_grupo,$quota_padrao,$cod_politica)";
                 $mysql->exesql($sql);
			  }
			  if ($jafez==0){
			     $jafez=1;
                 for ($cod=0;$cod<>$achou;$cod++) {
                       $sql="INSERT INTO $tabela_modulo_perl (cod_$tabela_modulo_perl,cod_usuario,quota,cod_politica)
                              VALUES (0,$vet_cod_usuario[$cod],$quota_padrao,$cod_politica)";
                       $mysql->exesql($sql);
				 }
              }
              //INICIALIZACAO AUTOMATICA
              // Todos os Dias
              if ($inicializacao==1) {
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'0','0',$cod_politica)";
                   $mysql->exesql($sql);
              }
              // Todos os inícios de Mes (Tipo mais utilizado)
              if ($inicializacao==2) {
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','0',$cod_politica)";
                   $mysql->exesql($sql);
              }
              // Todos os dias 1 de Janeiro e 1 de Julho
              if ($inicializacao==3) {
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','1',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','7',$cod_politica)";
                   $mysql->exesql($sql);
              }
              // Todos in�ios de Meses impares (Janeiro,Março,Maio,Julho,Setembro e Novembro)
              if ($inicializacao==4) {
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','1',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','3',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','5',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','7',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','9',$cod_politica)";
                   $mysql->exesql($sql);
                   $sql="INSERT INTO inicializacao
                         VALUES (0,'1','11',$cod_politica)";
                   $mysql->exesql($sql);
              }

         }
         for ($x=0;$x<count($cod_impressora);$x++){
            if ($impressora_valor[$x] <1) {
               $impressora_valor[$x]=1;
            }
            // Cadastra Conjunto Impressora
            $sql="INSERT INTO conjunto_impressora (cod_conjunto_impressora,cod_impressora,valor_impressao,
                                                   cod_politica)
                  VALUES(0,$cod_impressora[$x],$impressora_valor[$x],$cod_politica)";
            $mysql->exesql($sql);
         } // endFor

    } else { // Não compartilha quota com váias impressoras
             // Criar uma politica de impressão por impressora selecionada
         for ($W=0;$W<count($cod_impressora);$W++){
            // Cadastra Politica
            $sql="INSERT INTO politica (cod_politica,cod_tipo_politica,cod_grupo,quota_acumulativa,
                                quota_infinita,arquivo_banner,contabiliza_banner,quota_padrao)
                  VALUES(0,$cod_tipo_politica,$cod_grupo,$quota_acumulativa,$quota_infinita,
                        '$arquivo_banner',$contabiliza_banner,$quota_padrao)";
            $mysql->exesql($sql);
            $sql="SELECT max(politica.cod_politica) from politica";
            $mysql->exesql($sql);
            $row = mysql_fetch_row($mysql->consulta);
            $cod_politica = $row[0];
            if ($quota_infinita == 0) {
                 // Obtem usu�ios do grupo
                 $sql="SELECT usuario.cod_usuario from usuario
                       where usuario.cod_grupo=$cod_grupo";
                 $mysql->exesql($sql);
                 $achou = mysql_num_rows($mysql->consulta);
                 for ($cod=0;$cod<>$achou;$cod++) {
                    $row = mysql_fetch_row($mysql->consulta);
                    $vet_cod_usuario[$cod] = $row[0];
                 }
                 // Nome da tabela do modulo para se atualizar
                 $sql="SELECT tipo_politica.tabela_modulo_perl from tipo_politica
                       where tipo_politica.cod_tipo_politica=$cod_tipo_politica";
                 $mysql->exesql($sql);
                 $row = mysql_fetch_row($mysql->consulta);
                 $tabela_modulo_perl = $row[0];
                 if (($tabela_modulo_perl == "") or ($tabela_modulo_perl == "padrao") or ($tabela_modulo_perl == "0")) {
                      $tabela_modulo_perl="modp";
                 }
				 $jafez=0;
			     if ($tabela_modulo_perl == "grupop"){
			         $jafez=1;
                     $sql="INSERT INTO grupop (cod_grupop,cod_grupo,quota,cod_politica)
                           VALUES (0,$cod_grupo,$quota_padrao,$cod_politica)";
                     $mysql->exesql($sql);
			     }
			     if ($jafez==0){
			         $jafez=1;
                     for ($cod=0;$cod<>$achou;$cod++) {
                          $sql="INSERT INTO $tabela_modulo_perl (cod_$tabela_modulo_perl,cod_usuario,quota,cod_politica)
                               VALUES (0,$vet_cod_usuario[$cod],$quota_padrao,$cod_politica)";
                          $mysql->exesql($sql);
				     }
                 }
                 //INICIALIZACAO AUTOMATICA
                 // Todos os Dias
                 if ($inicializacao==1) {
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'0','0',$cod_politica)";
                      $mysql->exesql($sql);
                 }
                 // Todos os in�ios de Mes (Tipo mais utilizado)
                 if ($inicializacao==2) {
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','0',$cod_politica)";
                      $mysql->exesql($sql);
                 }
                 // Todos os dias 1 de Janeiro e 1 de Julho
                 if ($inicializacao==3) {
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','1',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','7',$cod_politica)";
                      $mysql->exesql($sql);
                 }
                 // Todos in�ios de Meses impares (Janeiro,Março,Maio,Julho,Setembro e Novembro)
                 if ($inicializacao==4) {
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','1',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','3',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','5',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','7',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','9',$cod_politica)";
                      $mysql->exesql($sql);
                      $sql="INSERT INTO inicializacao
                            VALUES (0,'1','11',$cod_politica)";
                      $mysql->exesql($sql);
                 }

            }
            // Cadastra Conjunto Impressora
    //        if ($impressora_valor[$W] <1) {
    //           $impressora_valor[$W]=1;
    //        }
            $sql="INSERT INTO conjunto_impressora (cod_conjunto_impressora,cod_impressora,valor_impressao,
                                                   cod_politica)
                  VALUES(0,$cod_impressora[$W],$impressora_valor[$W],$cod_politica)";
            $mysql->exesql($sql);
         }  // endfor

    }
    echo "<center>Pol&iacute;tica aplicada com sucesso!</center><br>";
    $destino_pagina=$_SERVER['PHP_SELF'];
    echo "<center><a href=\"$destino_pagina\">VOLTAR</a></center>";
 }

// FIM DO CORPO DA PAGINA
?>
<?php include 'rodape.php'; ?>
