#!/usr/bin/perl
# Contador de paginas.
# Este contador utiliza os recursos do IBQUOTA:
# http://www.ib.unicamp.br/ibquota
# Identificacao do FORMATO do ARQUIVO: PS,PCL,PCL3GUI e PCLXL
#
# 31/01/2005 - Valcir Cabral Vargas
# Caso encontre algum erro ou queira dar sugestao, por favor, 
#    entre em contato: valcir ( ARROBA ) unicamp (PONTO) br
# Utilize:
#         > perl pagecount.pl arquivo.ps

#Le funcoes do IBQUOTA
require "funcoes.pl";

# Verifica se arquivo Existe
my $arquivo=$ARGV[0];
if (!-e $arquivo) {
 print "Arquivo nao encontrado!\n";
 exit 0;
}

$page=PCL3GUICOUNTER($arquivo);
print "PCL3GUI=$page\n";
$page=PCLCOUNTER($arquivo);
print "PCL=$page\n";


# Verifica Formato
$formato=&FORMATO_ARQ($arquivo);
print "FORMATO=$formato\n";

if ($formato eq "PCL"){
 $page=PCLCOUNTER($arquivo);
 print "PCL=$page\n";
}

if ($formato eq "PS-PostScritp"){
 $page=PSCOUNTER($arquivo);
 print "PS=$page\n";
}

if ($formato eq "PCL3GUI"){
 $page=PCL3GUICOUNTER($arquivo);
 print "PCL3GUI=$page\n";
}

if ($formato eq "PCLXL") {
 $page=PCLXLCOUNTER($arquivo);
 print "PCLLX=$page\n";
}

# Se formato = NONE mostra tentar contar as paginas utilizando os contadores conhecidos
if ($formato eq "NONE") {
 print "Formato nao conhecido, tentando quantificar paginas pelos metodos conhecidos:\n";
 $page=PCLCOUNTER($arquivo);
 print "PCL=$page\n";
 $page=PSCOUNTER($arquivo);
 print "PS=$page\n";
 $page=PCL3GUICOUNTER($arquivo);
 print "PCL3GUI=$page\n";
 $page=PCLXLCOUNTER($arquivo);
 print "PCLLX=$page\n";
}
