#!/usr/bin/perl 
#
# IBQUOTA 2.4
# 29/03/04 - Valcir C.
#
# Inserir cabecalho padrao, com a GPL

#Adiciona as funcoes utilizadas
require "/opt/ibquota/funcoes.pl";

#Modulos de Politicas de Impressao
require "/opt/ibquota/modules/grupop.pl";

#use DBI();

#Ler as configuracoes
%configuracoes = LER_CONFIGURACOES("/opt/ibquota/ibquota.conf");

$dia = &DIA_DO_MES();
$hoje = $dia;
local $impressoras;
my $impressora;
local $arquivo_job;
local $SPOOL_IMPRESSORA;
#local $job;
while (1 == 1) { # "infinito"
   #Verifica se eh um novo dia, se sim, executar a funcao INICIALIZA_QUOTA_PADRAO
   $hoje = &DIA_DO_MES;
   if ($hoje != $dia) {
      &INICIALIZA_QUOTA_PADRAO();
      $dia = $hoje;
   }
  @impressoras = &LISTA_IMPRESSORAS();
  foreach $impressora (@impressoras) {
    @jobs = &LISTA_JOBS_IMPRESSORA($impressora);
    #Verifica se ha jobs
    if ($#jobs == -1) {
     next; # proxima impressora
    }
    $SPOOL_IMPRESSORA=&SPOOL_IMPRESSORA($impressora);
    foreach $job (@jobs) {
      $arquivo_job = &MONTA_ARQUIVO_JOB($job);
      if (&TESTA_JOB($SPOOL_IMPRESSORA . $arquivo_job) == 0) { 
        # Arquivo temporrio de impresso inexistente
        &GRAVA_LOG_IMPRESSOES(&DONO_JOB($impressora,$job),$impressora,4);
        &REMOVE_JOB($impressora,$job);
        next; # proximo job
      }
      $dono_job = &DONO_JOB($impressora,$job);
      if ($dono_job eq "NONE") { # Login nao identificado 
        &GRAVA_LOG("Login nao identificado: $impressora-$job ","ERRO");
        &REMOVE_JOB($impressora,$job);
        next; # proximo job
      }
      &EXECUTA_MODULO_IMPRESSAO_USUARIO($dono_job,$impressora,$arquivo_job);
    }
  }
  &DORMIR($configuracoes{'TEMPO_DE_ESPERA'});
}
