# IBQUOTA 2
# modulo grupop: Politica de Impressao por CENTRO DE CUSTO
# Valcir C. 19/08/04

sub GRUPOP() {
 #Testa de quota infinita
 if (&TESTA_QUOTA_INFINITA($dono_job,$impressora) == 1) {
   &IMPRIME_BANNER($dono_job,$impressora);
   &MANDA_ARQ_IMPRESSORA($impressora,$arquivo_job,$dono_job);
   &GRAVA_LOG_IMPRESSOES($dono_job,$impressora,1);
 } else {
   my $valor_por_pagina=&VALOR_PAGINA_IMPRESSAO($impressora,$dono_job);
   my $qtde_de_paginas=&NUMERO_PAGINAS_JOB(&SPOOL_IMPRESSORA($impressora) . $arquivo_job);
   my @exe=&EXECUTA_BANCO("select grupop.quota 
                                   from grupop,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where grupop.cod_grupo=usuario.cod_grupo
               and usuario.login='$dono_job'
               and politica.cod_politica=grupop.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");
   my $quota_grupop = $exe[0];
   @exe=&EXECUTA_BANCO("select grupop.cod_grupop
                                   from grupop,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where grupop.cod_grupo=usuario.cod_grupo
               and usuario.login='$dono_job'
               and politica.cod_politica=grupop.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");
   my $cod_grupop = $exe[0];
   my $valor_da_impressao = $qtde_de_paginas * $valor_por_pagina;
   if ($configuracoes{'DEBUG'} > 1) {
        print "GRUPOP: Quota_grupo = $quota_grupop | cod_grupop= $cod_grupop | paginas = $qtde_de_paginas | Valor= $valor_por_pagina\n\n";
   }
   my @contabiliza_banner=&EXECUTA_BANCO("select politica.contabiliza_banner
                                   from grupop,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where grupop.cod_grupo=usuario.cod_grupo
               and usuario.login='$dono_job'
               and politica.cod_politica=grupop.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");
      my @arquivo_banner=&EXECUTA_BANCO("select politica.arquivo_banner
                                   from grupop,usuario,politica,impressora
                                         ,conjunto_impressora
                                   where grupop.cod_grupo=usuario.cod_grupo
               and usuario.login='$dono_job'
               and politica.cod_politica=grupop.cod_politica
               and conjunto_impressora.cod_politica=politica.cod_politica
               and conjunto_impressora.cod_impressora=impressora.cod_impressora
               and impressora.nome_impressora='$impressora'");
   if ($arquivo_banner[0] eq "") {
       $contabiliza_banner=0;
   }
   if ($contabiliza_banner[0] == 1) {
      $valor_da_impressao = $valor_da_impressao + $valor_por_pagina;
   }
   # Ha quota?
   if ($quota_grupop >= $valor_da_impressao){
    &IMPRIME_BANNER($dono_job,$impressora);
    &MANDA_ARQ_IMPRESSORA($impressora,$arquivo_job,$dono_job);
    &GRAVA_LOG_IMPRESSOES($dono_job,$impressora,1);
    my $quota_atual = $quota_grupop - $valor_da_impressao; 
     # DEBITAR DA TABELA grupop
    my @execute=&EXECUTA_BANCO("update grupop set quota=$quota_atual where grupop.cod_grupop=$cod_grupop;");
   } else {
    # nao ha quota suficiente
    &GRAVA_LOG_IMPRESSOES($dono_job,$impressora,3);
   }
 }
 &REMOVE_JOB($impressora,$job);
}

print "Modulo: grupop (Politica de Impressao por Centro de Custo) carregado.\n";
